//
// PropertyUnitTypes.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct PropertyUnitTypes: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var unitTypeGarageAttachedYN: Bool?
    public var listingKeyNumeric: Double?
    public var unitTypeActualRent: Double?
    public var unitTypeBathsTotal: Double?
    public var unitTypeBedsTotal: Double?
    public var unitTypeGarageSpaces: Double?
    public var unitTypeKeyNumeric: Double?
    public var unitTypeProForma: Double?
    public var unitTypeTotalRent: Double?
    public var unitTypeUnitsTotal: Double?
    public var listingId: String?
    public var listingKey: String?
    public var unitTypeDescription: String?
    public var unitTypeKey: String?
    public var unitTypeType: String?
    public var modificationTimestamp: Date?
    public var property: Property?

    public init(id: Int? = nil, unitTypeGarageAttachedYN: Bool? = nil, listingKeyNumeric: Double? = nil, unitTypeActualRent: Double? = nil, unitTypeBathsTotal: Double? = nil, unitTypeBedsTotal: Double? = nil, unitTypeGarageSpaces: Double? = nil, unitTypeKeyNumeric: Double? = nil, unitTypeProForma: Double? = nil, unitTypeTotalRent: Double? = nil, unitTypeUnitsTotal: Double? = nil, listingId: String? = nil, listingKey: String? = nil, unitTypeDescription: String? = nil, unitTypeKey: String? = nil, unitTypeType: String? = nil, modificationTimestamp: Date? = nil, property: Property? = nil) {
        self.id = id
        self.unitTypeGarageAttachedYN = unitTypeGarageAttachedYN
        self.listingKeyNumeric = listingKeyNumeric
        self.unitTypeActualRent = unitTypeActualRent
        self.unitTypeBathsTotal = unitTypeBathsTotal
        self.unitTypeBedsTotal = unitTypeBedsTotal
        self.unitTypeGarageSpaces = unitTypeGarageSpaces
        self.unitTypeKeyNumeric = unitTypeKeyNumeric
        self.unitTypeProForma = unitTypeProForma
        self.unitTypeTotalRent = unitTypeTotalRent
        self.unitTypeUnitsTotal = unitTypeUnitsTotal
        self.listingId = listingId
        self.listingKey = listingKey
        self.unitTypeDescription = unitTypeDescription
        self.unitTypeKey = unitTypeKey
        self.unitTypeType = unitTypeType
        self.modificationTimestamp = modificationTimestamp
        self.property = property
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case unitTypeGarageAttachedYN = "UnitTypeGarageAttachedYN"
        case listingKeyNumeric = "ListingKeyNumeric"
        case unitTypeActualRent = "UnitTypeActualRent"
        case unitTypeBathsTotal = "UnitTypeBathsTotal"
        case unitTypeBedsTotal = "UnitTypeBedsTotal"
        case unitTypeGarageSpaces = "UnitTypeGarageSpaces"
        case unitTypeKeyNumeric = "UnitTypeKeyNumeric"
        case unitTypeProForma = "UnitTypeProForma"
        case unitTypeTotalRent = "UnitTypeTotalRent"
        case unitTypeUnitsTotal = "UnitTypeUnitsTotal"
        case listingId = "ListingId"
        case listingKey = "ListingKey"
        case unitTypeDescription = "UnitTypeDescription"
        case unitTypeKey = "UnitTypeKey"
        case unitTypeType = "UnitTypeType"
        case modificationTimestamp = "ModificationTimestamp"
        case property = "Property"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(unitTypeGarageAttachedYN, forKey: .unitTypeGarageAttachedYN)
        try container.encodeIfPresent(listingKeyNumeric, forKey: .listingKeyNumeric)
        try container.encodeIfPresent(unitTypeActualRent, forKey: .unitTypeActualRent)
        try container.encodeIfPresent(unitTypeBathsTotal, forKey: .unitTypeBathsTotal)
        try container.encodeIfPresent(unitTypeBedsTotal, forKey: .unitTypeBedsTotal)
        try container.encodeIfPresent(unitTypeGarageSpaces, forKey: .unitTypeGarageSpaces)
        try container.encodeIfPresent(unitTypeKeyNumeric, forKey: .unitTypeKeyNumeric)
        try container.encodeIfPresent(unitTypeProForma, forKey: .unitTypeProForma)
        try container.encodeIfPresent(unitTypeTotalRent, forKey: .unitTypeTotalRent)
        try container.encodeIfPresent(unitTypeUnitsTotal, forKey: .unitTypeUnitsTotal)
        try container.encodeIfPresent(listingId, forKey: .listingId)
        try container.encodeIfPresent(listingKey, forKey: .listingKey)
        try container.encodeIfPresent(unitTypeDescription, forKey: .unitTypeDescription)
        try container.encodeIfPresent(unitTypeKey, forKey: .unitTypeKey)
        try container.encodeIfPresent(unitTypeType, forKey: .unitTypeType)
        try container.encodeIfPresent(modificationTimestamp, forKey: .modificationTimestamp)
        try container.encodeIfPresent(property, forKey: .property)
    }
}

